import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class lines extends Applet{

    Button button1;
    String filename;
    int numberLines = 0, numberRectangles = 0;
    int lines[][] = new int[100][4];
    int rectangles[][] = new int[100][4];

    public static void main(String args[])
    {
        linesFrame frame = new linesFrame("The lines application");

        frame.show();
        frame.hide();
        frame.resize(400, 400);

        lines applet = new lines();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        filename = "file:////c://xml//lines//lines.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot());
            repaint();
        }
        return true;
    }


    void doTree(Element elem)
    {
        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() == com.ms.xml.Element.ELEMENT){
                if(elem2.getTagName().equals("LINE")){
                    lines[numberLines][0] = 
                        Integer.parseInt(elem2.getAttribute("X1"));
                    lines[numberLines][1] = 
                        Integer.parseInt(elem2.getAttribute("Y1"));
                    lines[numberLines][2] = 
                        Integer.parseInt(elem2.getAttribute("X2"));
                    lines[numberLines][3] = 
                        Integer.parseInt(elem2.getAttribute("Y2"));
                    numberLines++;
                    repaint();
                }
                if(elem2.getTagName().equals("RECTANGLE")){

                    rectangles[numberRectangles][0] = 
                        Integer.parseInt(elem2.getAttribute("X1"));
                    rectangles[numberRectangles][1] = 
                        Integer.parseInt(elem2.getAttribute("Y1"));
                    rectangles[numberRectangles][2] = 
                        Integer.parseInt(elem2.getAttribute("X2"));
                    rectangles[numberRectangles][3] = 
                        Integer.parseInt(elem2.getAttribute("Y2"));
                    numberRectangles++;
                    repaint();
                }
                doTree(elem2);
            }
        }
    }

    public void paint(Graphics g)
    {
        for(int index = 0; index < numberLines; index++){
            g.drawLine(lines[index][0], lines[index][1], lines[index][2], lines[index][3]);
        }
        for(int index = 0; index < numberRectangles; index++){
            g.drawRect(rectangles[index][0], rectangles[index][1], rectangles[index][2], rectangles[index][3]);
        }
    }
}    

class linesFrame extends Frame
{
    public linesFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }

}

