import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class choices extends Applet{

    static String filename;    
    static String displayStrings[] = new String[100];
    static int numberDisplayLines = 0;
    Choice choice;

    public static void main(String args[])
    {
        choicesFrame frame = new choicesFrame("The choices application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);
        Choice choice;

        choices applet = new choices();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        choice = new Choice();
        choice.addItem("Document 1");
        choice.addItem("Document 2");
        choice.addItem("Document 3");
        add(choice);
    }

    public boolean action (Event e, Object o)
    {
        numberDisplayLines = 0;
        URL url = null;

        try {
            if(e.target.equals(choice)){
                 switch(choice.getSelectedIndex()) { 
                     case 0: 
                         filename = "file:////c://xml//choices//choices1.xml";
                         break;
                     case 1: 
                         filename = "file:////c://xml//choices//choices2.xml";
                         break;
                     case 2: 
                         filename = "file:////c://xml//choices//choices3.xml";
                         break;
                 } 
                 url = new URL(filename);
            }
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }
        
        if (d != null) {
            doTree(d.getRoot(), "");
            repaint();
        }
            return true;
    }

    void doTree(Element elem, String indent)
    {
        String ind = "";

        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();
            if(elem2.getType() != com.ms.xml.Element.ELEMENT){

                int textLength = elem2.getText().length();
                displayStrings[numberDisplayLines++] = indent + elem2.getText().substring(0, textLength);

            }
            else{

                if(elem2.getTagName().equals("INDENTDOUBLE")){
                    ind = indent + "    ";
                }
                if(elem2.getTagName().equals("INDENT")){
                    ind = indent + "  ";
                }
                doTree(elem2, ind);
            }
        }
    }

    public void paint(Graphics g)
    {
        int y = 30;
        FontMetrics fontmetrics = getFontMetrics(getFont());

        for(int index = 0; index < numberDisplayLines; index++){
            y += fontmetrics.getHeight();
            g.drawString(displayStrings[index], 0, y);
        }
    }
}    

class choicesFrame extends Frame
{
    public choicesFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

