import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class circles extends Applet{

    Button button1;
    String filename = null;
    int numberFigures = 0;
    int x[] = new int[100];
    int y[] = new int[100];
    int width[] = new int[100];
    int height[] = new int[100];

    public static void main(String args[])
    {
        circlesFrame frame = new circlesFrame("The circles application");

        frame.show();
        frame.hide();
        frame.resize(400, 400);

        circles applet_app = new circles();

        frame.add("Center", applet_app);
        applet_app.init();
        applet_app.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o){

        URL url = null;
        String filename;

        filename = "file:////c://xml//circles//circles.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            doTree(d.getRoot());
            repaint();
        }
        return true;
    }


    void doTree(Element elem)
    {
        Enumeration enum = elem.getChildren();

        while (enum.hasMoreElements()) {
            Element elem2 = (Element)enum.nextElement();

            if(elem2.getType() == com.ms.xml.Element.ELEMENT){
                if(elem2.getTagName().equals("CIRCLE")){
                    x[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("X"));
                    y[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("Y"));
                    width[numberFigures] = 
                        2 * Integer.parseInt(elem2.getAttribute("RADIUS"));
                    height[numberFigures] = 
                        2 * Integer.parseInt(elem2.getAttribute("RADIUS"));
                    numberFigures++;
                    repaint();
                }
                if(elem2.getTagName().equals("ELLIPSE")){
                    x[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("X"));
                    y[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("Y"));
                    width[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("WIDTH"));
                    height[numberFigures] = 
                        Integer.parseInt(elem2.getAttribute("HEIGHT"));
                    numberFigures++;
                    repaint();
                }
                doTree(elem2);
            }
        }
    }

    public void paint(Graphics g)
    {
        for(int index = 0; index < numberFigures; index++){
            g.drawOval(x[index], y[index], width[index], height[index]);
        }
    }
}    

class circlesFrame extends Frame
{
    public circlesFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

