import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class idlocator extends Applet{

    static String filename;    
    TextField text1;
    Button button1;
    String rootString = "#ROOT()";

    public static void main(String args[])
    {
        idlocatorFrame frame = new idlocatorFrame("The idlocator application");

        frame.show();
        frame.hide();
        frame.resize(320, 320);

        idlocator applet = new idlocator();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        text1 = new TextField(20);
        add(text1);
        button1 = new Button("Display item with ID = X15");
        add(button1);
    }

    public boolean action (Event e, Object o)
    {
        
        String locator = "";
        URL url = null;
        filename = "file:////c://xml//idlocator//idlocator.xml";

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create url for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e2) {
            d.reportError(e2, System.out);
        }

        if (d != null) {
            Element root = d.getRoot();
            Enumeration enum = root.getChildren();
            while (enum.hasMoreElements()) {
                Element elem = (Element)enum.nextElement();
                if (elem.getTagName().equals("LOCATOR")) {

                    URL url2 = null;
                    try {
                        locator = new String(elem.getAttribute("HREF"));
                        url2 = new 
                            URL(locator.substring(0, 
                            locator.indexOf("#")));
                    } catch (MalformedURLException e3) {
                        System.out.println("Cannot create URL for: " + 
                            filename);
                        System.exit(0);
                    }
            
                    Document d2 = new Document(); 

                    try {
                        d2.load(url2);
                    } 
                    catch (ParseException e4) {
                        d2.reportError(e4, System.out);
                    }

                    Element newRoot = d2.getRoot();

                    String IDName = 
                        locator.substring(locator.indexOf(rootString) + 
                        rootString.length());

                    Element elem2 = null; 
                    Element target = null; 
                    Enumeration enum2 = newRoot.getChildren();

                    while (enum2.hasMoreElements()) {
                        elem2 = (Element)enum2.nextElement();
                        if(elem2.getAttribute("ID") != null){
                            if(elem2.getAttribute("ID").equals(IDName)){
                                text1.setText(elem2.getText());
                            }
                        }
                    }
                }
            }
        }
        return true;
    }
}    

class idlocatorFrame extends Frame
{
    public idlocatorFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

