import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;

public class imagebrowser extends Applet{

    static String filename;    
    Button button1;
    boolean imageReady = false;
    Image image = null;
    Element imageElement = null;

    public static void main(String args[])
    {
        imagebrowserFrame frame = new imagebrowserFrame("The imagebrowser application");

        frame.resize(320, 320);

        imagebrowser applet = new imagebrowser();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        button1 = new Button("Browse");
        add(button1);
    }

    public boolean action (Event e, Object o)
    {
        filename = "file:////c://xml//imagebrowser//imagebrowser.xml";
        URL url = null;

        try {
            url = new URL(filename);
        } catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        Document d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }

        if (d != null) {
            Element elem = d.getRoot();
            Enumeration enum = elem.getChildren();

            while (enum.hasMoreElements()) {
                Element elem2 = (Element)enum.nextElement();
                if(elem2.getType() == com.ms.xml.Element.ELEMENT){
                    if(elem2.getTagName().equals("IMG")){
                           
                        image = Toolkit.getDefaultToolkit().getImage(elem2.getAttribute("SRC"));
                        MediaTracker tracker = new MediaTracker(this);
                        tracker.addImage(image, 0);
                        try{
                            tracker.waitForAll();
                        }
                        catch(InterruptedException e0){
                        }
                        imageElement = elem2;
                        imageReady = true;
                    }
                }
            }
            repaint();
        }
        return true;
    }

    public void paint(Graphics g)
    {
        if(imageReady){
            g.drawImage(image, 
            Integer.parseInt(imageElement.getAttribute("X")), 
            Integer.parseInt(imageElement.getAttribute("Y")), 
            Integer.parseInt(imageElement.getAttribute("WIDTH")), 
            Integer.parseInt(imageElement.getAttribute("HEIGHT")), 
            this);
        }
    }
}    

class imagebrowserFrame extends Frame
{
    public imagebrowserFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

