import com.ms.xml.ParseException;
import com.ms.xml.Document;
import com.ms.xml.Element;

import java.util.Enumeration;
import java.awt.*;
import java.net.*;
import java.applet.Applet;


public class medicines extends Applet{

    static String filename;    
    Label firstNameLabel, lastNameLabel;
    TextField text1, text2;
    TextField medicine1, medicine2, medicine3;
    Button button1, button2;
    Document d;
    int currentRecordNumber = 0;
               
    public static void main(String args[])
    {
        medicinesFrame frame = new medicinesFrame("The medicines application");

        frame.show();
        frame.hide();
        frame.resize(320, 240);

        medicines applet = new medicines();

        frame.add("Center", applet);
        applet.init();
        applet.start();
        frame.show();
    }

    public void init(){
        firstNameLabel = new Label("First Name:");
        add(firstNameLabel);
        text1 = new TextField(24);
        add(text1);
        lastNameLabel = new Label("Last Name:");
        add(lastNameLabel);
        text2 = new TextField(24);
        add(text2);
        medicine1 = new TextField(35);
        add(medicine1);
        medicine2 = new TextField(35);
        add(medicine2);
        medicine3 = new TextField(35);
        add(medicine3);
        button1 = new Button("<");
        add(button1);
        button2 = new Button(">");
        add(button2);

        URL url = null;
        try {
            url = new URL("file:////c://xml//medicines//medicines.xml");
        } 
        catch (MalformedURLException e1) {
            System.out.println("Cannot create URL for: " + filename);
            System.exit(0);
        }
            
        d = new Document(); 

        try {
            d.load(url);
        } 
        catch (ParseException e3) {
            d.reportError(e3, System.out);
        }
        if (d != null) {
            showRecord(0);
        }
    }

    public boolean action (Event e, Object o){

        if(e.target.equals(button1)){  //The < button
            if(currentRecordNumber > 0){
                currentRecordNumber--;
            }
            showRecord(currentRecordNumber);
        }
        if(e.target.equals(button2)){  //The > button
            if(currentRecordNumber < 4){
                currentRecordNumber++;
            }
                showRecord(currentRecordNumber);
        }

        return true;
    }

    void showRecord(int recordNumber)
    {
        Element root = d.getRoot();
        Element elem = null, elem2 = null;
        Enumeration enum = root.getChildren();
        for(int index = 0; index <= recordNumber; index++){
            elem = (Element)enum.nextElement();
        }
        medicine1.setText("");
        medicine2.setText("");
        medicine3.setText("");

        Enumeration enum2 = elem.getChildren();
        while(enum2.hasMoreElements()){

            elem2 = (Element)enum2.nextElement();

            if (elem2.getTagName().equals("FIRSTNAME")) {
                text1.setText(elem2.getText());
            }

            if (elem2.getTagName().equals("LASTNAME")) {
                text2.setText(elem2.getText());
            }

            if (elem2.getTagName().equals("MEDICINE")) {
                if(medicine1.getText().equals("")){
                    medicine1.setText(elem2.getText());
                }
                else if(medicine2.getText().equals("")){
                    medicine2.setText(elem2.getText());
                }
                else if(medicine3.getText().equals("")){
                    medicine3.setText(elem2.getText());
                }
            }
        }
    }
}    

class medicinesFrame extends Frame
{
    public medicinesFrame(String str)
    {
        super (str);
    }

    public boolean handleEvent(Event evt)
    {
        switch (evt.id)
        {
            case Event.WINDOW_DESTROY:
                dispose();
                System.exit(0);
                return true;

            default:
                return super.handleEvent(evt);
        }             
    }
}

